﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Concept.Utils;
using Ocf;

namespace OcfApiServerDemo
{
    class Generator
    {
        public Generator()
        {
            Initialize();
        }

        public double SignalValue { get; set; }

        public double Frequency { get; set; }

        public double Amplitude { get; set; }

        public void Run()
        {
            SignalValue = Amplitude * Math.Sin(Frequency * _timer.Time / 1000.0 * 2.0 * Math.PI);
        }

        private void Initialize()
        {
            SignalValue = 0;
            Frequency = 1;
            Amplitude = 1;
            _timer = new UpTimer();
            _timer.Start();
        }

        private UpTimer _timer;
    }

    class Program
    {
        static void Main(string[] args)
        {
            const int Port = 10000;

            Generator MyGenerator = new Generator();
            OcfApiServer server = OcfApi.CreateOcfNativeUdpServer(Port, MyGenerator);

            Console.WriteLine(@"  ____  _     _           _   _                  __ _                          ");
            Console.WriteLine(@" / __ \| |   (_)         | | (_)                / _| |                         ");
            Console.WriteLine(@"| |  | | |__  _  ___  ___| |_ _ ___   ___  ___ | |_| |___      ____ _ _ __ ___ ");
            Console.WriteLine(@"| |  | | '_ \| |/ _ \/ __| __| / __| / __|/ _ \|  _| __\ \ /\ / / _` | '__/ _ \");
            Console.WriteLine(@"| |__| | |_) | |  __/ (__| |_| \__ \ \__ \ (_) | | | |_ \ V  V / (_| | | |  __/");
            Console.WriteLine(@" \____/|_.__/| |\___|\___|\__|_|___/ |___/\___/|_|  \__| \_/\_/ \__,_|_|  \___|");
            Console.WriteLine(@"            _/ |                                                               ");
            Console.WriteLine(@"           |__/                                                                ");

            Console.WriteLine();

            Console.WriteLine(@"This is a Ocf Server (OcfApi) demo. All rights reserved.");
            Console.WriteLine(@"Please contact Objectis S.A. on www.objectis-software.com for more information.");
            Console.WriteLine(@"Server started on port: " + Port);

            Console.WriteLine();

            for (; ; )
            {
                MyGenerator.Run();
                OcfApi.ExecuteOcfServer(server);
            }
        }
    }
}
